package com.renderx.xepx.x4u.ct;

import java.awt.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.border.*;
import java.awt.event.*;
import javax.swing.event.*;
import java.util.*;
import org.w3c.dom.Document;
import org.w3c.dom.*;
import org.w3c.dom.Node;
import java.net.*;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2004</p>
 * <p>Company: </p>
 * @author not attributable
 * @version 1.0
 */

public class FontsPanel extends JPanel {

  // Font option variable
  public static String DEFAULTFONT = null;

//  public static String FONTS_HREF = null; @todo: not supported yet
  public static final String[] COMBO_VALUE  = {"unspecified", "true", "false"};
  public static final String[] NEW_COMMANDS = {"AddGroup","AddFamily","AddFont"};
//  static final String[] zoomValue = {"none","fit screen","fit width","fit height","number or percentage "};
//  static final String[] viewValue = {"none","show none","show bookmarks","show thumbnails","full screen"};

  JTree fontsTree;

  protected DomToJTreeAdapter domModel;
  Document doc;

  BorderLayout borderLayout1 = new BorderLayout();
  Border border1;
  JPanel parametersPanel = new JPanel();
  Border border2;
  TitledBorder titledBorder1;
  BorderLayout borderLayout2 = new BorderLayout();
  JPanel treePanel = new JPanel();
  JPanel detailPanel = new JPanel();
  JScrollPane fontsScrollPane = new JScrollPane();
  JSplitPane jSplitPane1 = new JSplitPane();
  GridLayout gridLayout1 = new GridLayout();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  BorderLayout borderLayout3 = new BorderLayout();
  JPanel commonPanel = new JPanel();
  JPanel commandPanel = new JPanel(); // = new JTable();
  JButton deleteButton = new JButton();
  JButton groupButton = new JButton();
  JButton familyButton = new JButton();
  JButton fontButton = new JButton();
  JLabel xmlLabel = new JLabel();
  JTextField xmlTextField = new JTextField();
  JButton browseButton = new JButton();
  GridBagLayout gridBagLayout3 = new GridBagLayout();
  Border border3;
  TitledBorder titledBorder2;
  JPanel nodeDscPanel = new JPanel();
  JComboBox embedComboBox = new JComboBox(COMBO_VALUE);
  JLabel embedLabel = new JLabel();
  JComboBox subsetComboBox = new JComboBox(COMBO_VALUE);
  JLabel subsetLabel = new JLabel();
  JPanel fontsDataPanel = new JPanel();
  JScrollPane fontDetScrollPane = new JScrollPane();
  JTable fontDetTable;///// = new JTable();
  GridLayout gridLayout2 = new GridLayout();
  JPanel transformPanel = new JPanel();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  BorderLayout borderLayout4 = new BorderLayout();
  Border border4;
  TitledBorder titledBorder3;
  JPanel slantPanel = new JPanel();
  JTextField slantTextField = new JTextField();
  JCheckBox slantCheckBox = new JCheckBox();
  JPanel smallcapPanel = new JPanel();
  JCheckBox smallcapCheckBox = new JCheckBox();
  JTextField smallcapTextField = new JTextField();
  JPanel aliasPanel = new JPanel();
  JScrollPane aliasScrollPane = new JScrollPane();
  JTable aliasTable;
  Border border5;
  TitledBorder titledBorder4;
  GridLayout gridLayout3 = new GridLayout();
  Border border6;
  TitledBorder titledBorder5; // = new JTable();
  Element fontNode = null;
  JPanel dataCommandsPanel = new JPanel();
  JButton deleteDataButton = new JButton();
  JButton addDataButton = new JButton();


  public FontsPanel(Document dw) {
    this.doc = dw;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    border1 = new EtchedBorder(EtchedBorder.RAISED, Color.white, new Color(148, 145, 140));
    border2 = new EtchedBorder(EtchedBorder.RAISED, Color.white, new Color(148, 145, 140));
    titledBorder1 = new TitledBorder(new EtchedBorder(EtchedBorder.RAISED, Color.white,
                                                      new Color(148, 145, 140)), "Supported Fonts");
    border3 = BorderFactory.createEmptyBorder();
    titledBorder2 = new TitledBorder(border3, "Common Attributes");
    border4 = BorderFactory.createEmptyBorder();
    titledBorder3 = new TitledBorder(border4, "Transformation");
    border5 = BorderFactory.createEmptyBorder();
    titledBorder4 = new TitledBorder(border5, "Font Aliases");
    border6 = BorderFactory.createEmptyBorder();
    titledBorder5 = new TitledBorder(border6, "Font data");
    smallcapTextField.setText("  1 ");
    /*    smallcapTextField.addFocusListener(new java.awt.event.FocusAdapter() {
          public void focusLost(FocusEvent e) {
            smallcapTextField_focusLost(e,(Element)fontNode);
          }
        });*/
    smallcapTextField.setPreferredSize(new Dimension(40, 19));
    smallcapTextField.setEnabled(false);
    smallcapTextField.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusLost(FocusEvent e) {
        textField_focusLost(e, (Element) fontNode);
      }

      public void focusGained(FocusEvent e) {
        textField_focusGained(e, (Element) fontNode);
      }
    });

    smallcapTextField.setName("smallcaps");
    smallcapCheckBox.setText("Smallcaps");
    smallcapCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        smallcapCheckBox_actionPerformed(e, (Element) fontNode);
      }
    });
    this.setLayout(borderLayout1);
    parametersPanel.setBorder(titledBorder1);
    parametersPanel.setLayout(borderLayout2);
    detailPanel.setLayout(borderLayout3);
    treePanel.setPreferredSize(new Dimension(160, 300));
    treePanel.setLayout(gridLayout1);
    jSplitPane1.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
    jSplitPane1.setPreferredSize(new Dimension(350, 300));
    jSplitPane1.setDividerLocation(300);
    gridLayout1.setColumns(1);
    gridLayout1.setRows(0);
    commonPanel.setLayout(gridBagLayout3);
    groupButton.setActionCommand(NEW_COMMANDS[0]);
    groupButton.setText("New Group");
    groupButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        new_actionPerformed(e);
      }
    });
    familyButton.setText("New Family");
    familyButton.setActionCommand(NEW_COMMANDS[1]);
    familyButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        new_actionPerformed(e);
      }
    });
    fontButton.setText("New Font");
    fontButton.setActionCommand(NEW_COMMANDS[2]);
    fontButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        new_actionPerformed(e);
      }
    });

    deleteButton.setText("Delete Node");
    deleteButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        deleteButton_actionPerformed(e);
      }
    });

    xmlLabel.setPreferredSize(new Dimension(70, 15));
    xmlLabel.setText("Base path:");
    xmlTextField.setPreferredSize(new Dimension(70, 19));
    xmlTextField.setText("");
    xmlTextField.setName("xmlbase");
    xmlTextField.addFocusListener(new java.awt.event.FocusAdapter() {
          public void focusLost(FocusEvent e) {
            textField_focusLost(e, (Element) fontNode);
          }

          public void focusGained(FocusEvent e) {
            textField_focusGained(e, (Element) fontNode);
          }
        });

    browseButton.setText("Browse");
    browseButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        browseButton_actionPerformed(e,(Element)fontNode);
      }
    });
//    browseButton.setNextFocusableComponent(xmlTextField);
    commonPanel.setBorder(titledBorder2);
    embedLabel.setText("Embedded:");
    subsetLabel.setText("Subsetted:");

    fontsDataPanel.setLayout(gridLayout2);
    gridLayout2.setColumns(1);
    gridLayout2.setRows(0);
    nodeDscPanel.setLayout(borderLayout4);
    nodeDscPanel.setVisible(false);
    transformPanel.setLayout(gridBagLayout1);
    transformPanel.setBorder(titledBorder3);
//    transformPanel.addComponentListener();
    /*    transformPanel.addFocusListener(new java.awt.event.FocusAdapter() {
          public void focusLost(FocusEvent e) {
            transformPanel_focusLost(e, (Element)fontNode);
          }
        });*/
    slantTextField.setEnabled(false);
    slantTextField.setPreferredSize(new Dimension(40, 19));
    slantTextField.setText("  15");
    slantTextField.addFocusListener(new java.awt.event.FocusAdapter() {
      public void focusLost(FocusEvent e) {
        textField_focusLost(e, (Element) fontNode);
      }

      public void focusGained(FocusEvent e) {
        textField_focusGained(e, (Element) fontNode);
      }
    });
    slantTextField.setName("slant");
    slantCheckBox.setText("Slanting");
    slantCheckBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        slantCheckBox_actionPerformed(e, (Element) fontNode);
      }
    });

    aliasPanel.setVisible(false);
    fontsDataPanel.setBorder(titledBorder5);
    embedComboBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        embedComboBox_actionPerformed(e);
      }
    });
    subsetComboBox.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        subsetComboBox_actionPerformed(e);
      }
    });
    deleteDataButton.setText("Delete");
    deleteDataButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        deleteDataButton_actionPerformed(e, (Element) fontNode);
      }
    });
    addDataButton.setText("Add");
    addDataButton.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        addDataButton_actionPerformed(e, (Element) fontNode);
      }
    });
    this.add(parametersPanel, BorderLayout.CENTER);
    parametersPanel.add(jSplitPane1, BorderLayout.CENTER);
    jSplitPane1.add(treePanel, JSplitPane.TOP);
    treePanel.add(fontsScrollPane, null);
    domModel = new DomToJTreeAdapter(this.doc);
    fontsTree = new JTree(domModel); //new DomToTreeModelAdapter());
    fontsTree.setEditable(true);
    fontsTree.setVisible(true);
    fontsScrollPane.getViewport().add(fontsTree, null);
    fontsTree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
    fontsTree.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
      public void valueChanged(TreeSelectionEvent e) {
        fontsTree_valueChanged(e);
      }
    });
    fontsTree.setSelectionRow(0);
    jSplitPane1.add(detailPanel, JSplitPane.BOTTOM);
    detailPanel.add(commonPanel, BorderLayout.NORTH);
    commandPanel.add(groupButton, null);
    commandPanel.add(familyButton, null);
    commandPanel.add(fontButton, null);
    commandPanel.add(deleteButton, null);
    fontDetScrollPane.getViewport().add(fontDetTable, null);

    detailPanel.add(nodeDscPanel,  BorderLayout.CENTER);
    nodeDscPanel.add(fontsDataPanel, BorderLayout.CENTER);
    commonPanel.add(xmlLabel,  new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    commonPanel.add(xmlTextField,     new GridBagConstraints(1, 0, 2, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(5, 5, 5, 5), 0, 0));
    commonPanel.add(embedComboBox,    new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    commonPanel.add(embedLabel,    new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    commonPanel.add(subsetComboBox,    new GridBagConstraints(3, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(5, 5, 5, 5), 0, 0));
    commonPanel.add(subsetLabel,  new GridBagConstraints(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(5, 5, 5, 5), 0, 0));
    commonPanel.add(browseButton,     new GridBagConstraints(3, 0, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 0, 5, 0), 0, 0));
    fontsDataPanel.add(fontDetScrollPane, null);
    nodeDscPanel.add(transformPanel, BorderLayout.NORTH);
    transformPanel.add(slantPanel, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0
                                                          , GridBagConstraints.CENTER,
                                                          GridBagConstraints.NONE,
                                                          new Insets(0, 0, 0, 0), 0, 0));
    slantPanel.add(slantCheckBox, null);
    slantPanel.add(slantTextField, null);
    transformPanel.add(smallcapPanel, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0
        , GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    smallcapPanel.add(smallcapCheckBox, null);
    smallcapPanel.add(smallcapTextField, null);
    dataCommandsPanel.setVisible(false);
    detailPanel.add(dataCommandsPanel,  BorderLayout.SOUTH);
    parametersPanel.add(commandPanel, BorderLayout.SOUTH);
    aliasScrollPane.getViewport().add(aliasTable, null);
    dataCommandsPanel.add(addDataButton, null);
    dataCommandsPanel.add(deleteDataButton, null);
  }

  public void setCommonAttribs(org.w3c.dom.Node node) {
    NamedNodeMap attribs = node.getAttributes();

    this.embedComboBox.setSelectedIndex( (attribs.getNamedItem("embed") == null) ? 0 :
                   ((attribs.getNamedItem("embed").getNodeValue().toString()).equalsIgnoreCase("true")) ? 1 : 2);
    this.subsetComboBox.setSelectedIndex( (attribs.getNamedItem("subset") == null) ? 0 :
                   ((attribs.getNamedItem("subset").getNodeValue().toString()).equalsIgnoreCase("true")) ? 1 : 2);
    this.xmlTextField.setText( (attribs.getNamedItem("xml:base") == null) ? COMBO_VALUE[0] :
                              attribs.getNamedItem("xml:base").getNodeValue());
  }

  public static String getDefFont() { // ToDo: check for null
    if (DEFAULTFONT == null)
      //getElementsByTagName(rootName);
      DEFAULTFONT = DOMWalker.fntRoot.getAttribute("default-family");
  //DOMWalker.getSubTree("fonts").item(0).getAttributes().getNamedItem(
          //"default-family").getNodeValue();
    return DEFAULTFONT;
  }

/**/

  /*
    String getFontData(Node node){
      String res = "";
      NamedNodeMap attribs = node.getAttributes();
      if (attribs.getNamedItem("afm")  != null) res += "afm-source "+ attribs.getNamedItem("afm").getNodeValue()+" ";
      if (attribs.getNamedItem("pfa")  != null) res += "pfa-source "+ attribs.getNamedItem("pfa").getNodeValue()+" ";
      if (attribs.getNamedItem("pfb")  != null) res += "pfb-source "+ attribs.getNamedItem("pfb").getNodeValue()+" ";
      if (attribs.getNamedItem("ttf")  != null) res += "ttf-source "+ attribs.getNamedItem("ttf").getNodeValue()+" ";
      if (attribs.getNamedItem("otf")  != null) res += "otf-source "+ attribs.getNamedItem("otf").getNodeValue()+" ";
      if (attribs.getNamedItem("cff")  != null) res += "cff-source "+ attribs.getNamedItem("cff").getNodeValue()+" ";
      if (attribs.getNamedItem("glyph-list")  != null)
        res += "Glyphs = "+ attribs.getNamedItem("glyph-list").getNodeValue()+" ";
      if (attribs.getNamedItem("adobe-ordering")  != null)
        res += "Adobe ordering = "+ attribs.getNamedItem("adobe-ordering").getNodeValue()+" ";
      if (attribs.getNamedItem("adobe-encoding")  != null)
        res += "Adobe encoding = "+ attribs.getNamedItem("adobe-encoding").getNodeValue()+" ";
      if (attribs.getNamedItem("adobe-supplement")  != null)
        res += "Adobe supplement = "+ attribs.getNamedItem("adobe-supplement").getNodeValue()+" ";
      return res;
    }*/

  void setFontTrans(Node node) {
//    String res = "Transformation: ";
    if (node == null) return; // for inserted nodes
    NamedNodeMap attribs = node.getAttributes();
    if (attribs.getNamedItem("slant-angle") != null) {
      this.slantCheckBox.setSelected(true);
      this.slantTextField.setText(attribs.getNamedItem("slant-angle").getNodeValue());
      this.slantTextField.setEnabled(true);
    }
    else {
      this.slantCheckBox.setSelected(false);
      this.slantTextField.setText("15");
      this.slantTextField.setEnabled(false);
    }
    this.slantPanel.updateUI();
    if (attribs.getNamedItem("smallcap-size") != null) {
      this.smallcapCheckBox.setSelected(true);
      this.smallcapTextField.setText(attribs.getNamedItem("smallcap-size").getNodeValue());
      this.smallcapTextField.setEnabled(true);
    }
    else {
      this.smallcapCheckBox.setSelected(false);
      this.smallcapTextField.setText("1");
      this.smallcapTextField.setEnabled(false);
    }
    this.smallcapPanel.updateUI();
    transformPanel.updateUI();
//      res += "Smallcap size = "+ attribs.getNamedItem("smallcap-size").getNodeValue()+" ";
//    return res.trim();

  }

/*  void fontsTree_removeCurrentNode(TreeModelEvent e) {
    domModel.removeCurrentNode(e.getTreePath());
  }*/

  void fontsTree_valueChanged(TreeSelectionEvent e) {
    TreePath p = e.getNewLeadSelectionPath();
    fontNode = null;
    if (p == null)return;
    DomToJTreeAdapter.FontTreeNode node = (DomToJTreeAdapter.FontTreeNode) p.getLastPathComponent();
////////////System.out.println("CURRENT NODE="+node.body);
    fontNode = node.body;
    setCommonAttribs(node.body);
    dataCommandsPanel.setVisible(false); // show only for font nodes
    if (node.body.getNodeName() == "font-group" || node.body.getNodeName() == "fonts") {
      this.fontButton.setEnabled(false);
      this.familyButton.setEnabled(true);
      this.groupButton.setEnabled(true);
      nodeDscPanel.setVisible(false);
      detailPanel.remove(aliasPanel);
      aliasPanel = new FontAliasesPanel(node.body);
      aliasPanel.setVisible(true);
      detailPanel.add(aliasPanel, BorderLayout.CENTER);
      detailPanel.updateUI();
    } else {
      this.fontButton.setEnabled(true);
      this.familyButton.setEnabled(false);
      this.groupButton.setEnabled(false);
      aliasPanel.setVisible(false);
      this.fontDetScrollPane.getViewport().removeAll();
      if (node.body.getNodeName() == "font") {
//////        dataCommandsPanel.setVisible(false);
        nodeDscPanel.setVisible(true);
        dataCommandsPanel.setVisible(true);
//if(fontNode.hasChildNodes())
///System.out.println("Font child=" + fontNode.getAttributes().toString());
/////        NodeList subNodeList = node.body.getChildNodes();
        NodeList children = node.body.getElementsByTagName("font-data");
        if(children.getLength() == 0)
          fontDetTable = null;
        else{
          fontDetTable = new JTable( new DomToTableModel((Element)node.body,true));//////currNode,true));
          this.fontDetScrollPane.getViewport().add(fontDetTable, null);
        }
        children = node.body.getElementsByTagName("transform");
        if(children.getLength() > 0)
          setFontTrans(children.item(0));
        else{//// set default values
          this.slantCheckBox.setSelected(false);
          this.slantTextField.setText("15");
          this.slantTextField.setEnabled(false);
          this.smallcapCheckBox.setSelected(false);
          this.smallcapTextField.setText("1");
          this.smallcapTextField.setEnabled(false);
        }
/*
        Node currNode = null;
        if(subNodeList != null){
          for (int i = 0; i < subNodeList.getLength(); i++) {
            currNode = subNodeList.item(i);
            if (currNode.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE){
              if(currNode.getNodeName() == "font-data") {
//System.out.println("Font child=" + currNode.toString());
                fontDetTable = new JTable( new DomToTableModel((Element)node.body,true));//////currNode,true));
                this.fontDetScrollPane.getViewport().add(fontDetTable, null);
              }
              else ///"transform")
                setFontTrans(currNode);
            }
          }
        }*/
      }
      else {
        nodeDscPanel.setVisible(false);
      }
      this.fontDetScrollPane.updateUI();
    }
  }

  JTable setFontDataTable(Node node) {
    NamedNodeMap attribs = node.getAttributes();
    if(attribs == null) return new JTable(0,2);
//System.out.println(" FONT DATA="+attribs.toString());
    String[][] tmp = new String[attribs.getLength()][2];
    int i = 0;
    if (attribs.getNamedItem("afm") != null) {
      tmp[i][0] = "afm";
      tmp[i][1] = attribs.getNamedItem("afm").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("pfa") != null) {
      tmp[i][0] = "pfa";
      tmp[i][1] = attribs.getNamedItem("pfa").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("pfb") != null) {
      tmp[i][0] = "pfb";
      tmp[i][1] = attribs.getNamedItem("pfb").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("ttf") != null) {
      tmp[i][0] = "ttf";
      tmp[i][1] = attribs.getNamedItem("ttf").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("otf") != null) {
      tmp[i][0] = "otf";
      tmp[i][1] = attribs.getNamedItem("otf").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("cff") != null) {
      tmp[i][0] = "cff";
      tmp[i][1] = attribs.getNamedItem("cff").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("glyph-list") != null) {
      tmp[i][0] = "glyph-list";
      tmp[i][1] = attribs.getNamedItem("glyph-list").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("adobe-ordering") != null) {
      tmp[i][0] = "adobe-ordering";
      tmp[i][1] = attribs.getNamedItem("adobe-ordering").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("adobe-encoding") != null) {
      tmp[i][0] = "adobe-encoding";
      tmp[i][1] = attribs.getNamedItem("adobe-encoding").getNodeValue();
      i++;
    }
    if (attribs.getNamedItem("adobe-supplement") != null) {
      tmp[i][0] = "adobe-supplement";
      tmp[i][1] = attribs.getNamedItem("adobe-supplement").getNodeValue();
      i++;
    }
    String[] nm = {"", ""};
    JTable res = new JTable(tmp, nm);
    return res;
  }

  /**
   * FontPanel service commands
   * @params e Action or Focus Event
   *         node DOM element to be managed
   */
  void slantCheckBox_actionPerformed(ActionEvent e, Element node) {

		boolean state = slantCheckBox.isSelected();
    if (node == null) return;
    Element transform;
    NodeList children = node.getElementsByTagName("transform");
    if(children.getLength() == 0)
    {
      transform = node.getOwnerDocument().createElement("transform");
      node.appendChild(transform);
    }
    else
    {
        transform = (Element)children.item(0);
    }

    if (state && slantTextField.getText().trim().length() > 0 &&
        Integer.parseInt(slantTextField.getText().trim()) != 15)
      transform.setAttribute("slant-angle", slantTextField.getText());

    if (!state)
    {
      transform.removeAttribute("slant-angle");
      if(transform.getAttributes().getLength() == 0)
        node.removeChild(transform);
    }

    slantTextField.setEnabled(state);

  }

  void smallcapCheckBox_actionPerformed(ActionEvent e, Element node) {
    boolean state = smallcapCheckBox.isSelected();
    if (node == null) return;
    Element transform;
    NodeList children = node.getElementsByTagName("transform");
    if(children.getLength() == 0)
    {
      transform = node.getOwnerDocument().createElement("transform");
      node.appendChild(transform);
    }
    else
    {
        transform = (Element)children.item(0);
    }

    if (state && smallcapTextField.getText().trim().length() > 0 &&
        Integer.parseInt(smallcapTextField.getText().trim()) != 1)
      transform.setAttribute("smallcap-size", smallcapTextField.getText());

    if (!state)
    {
      transform.removeAttribute("smallcap-size");
      if(transform.getAttributes().getLength() == 0)
        node.removeChild(transform);
    }

    smallcapTextField.setEnabled(state);
  }

  String currTextValue = "";

  void textField_focusGained(FocusEvent e, Element node) {
    String cmd = ( (JTextField) e.getSource()).getName();
    if (cmd.equalsIgnoreCase("slant")) currTextValue = slantTextField.getText().trim();
    else if (cmd.equalsIgnoreCase("xmlbase")) currTextValue = xmlTextField.getText().trim();
    else if (cmd.equalsIgnoreCase("smallcaps")) currTextValue = smallcapTextField.getText().trim();
  }

  void textField_focusLost(FocusEvent e, Element node) {
    if (node == null)  return;
    Element transform;
    String cmd = ((JTextField) e.getSource()).getName();
    if (cmd.equalsIgnoreCase("slant") &&
        currTextValue != slantTextField.getText().trim()) {
      transform = (Element)node.getElementsByTagName("transform").item(0);
      if (slantTextField.getText().trim().length() == 0)
        transform.removeAttribute("slant-angle");
      else
        transform.setAttribute("slant-angle", slantTextField.getText());
    }
    else if (cmd.equalsIgnoreCase("smallcaps") &&
             currTextValue != smallcapTextField.getText().trim()) {
      transform = (Element)node.getElementsByTagName("transform").item(0);
      if (smallcapTextField.getText().trim().length() == 0)
        transform.removeAttribute("smallcap-size");
      else
        transform.setAttribute("smallcap-size", smallcapTextField.getText());
    }
    else if (cmd.equalsIgnoreCase("xmlbase") &&
             currTextValue != xmlTextField.getText().trim()) {
      if (xmlTextField.getText().trim().length() == 0 || xmlTextField.getText().equalsIgnoreCase(COMBO_VALUE[0]))
        node.removeAttribute("xml:base");
      else
        node.setAttribute("xml:base", xmlTextField.getText());
    }
//////    System.out.println("Com"+cmd+" Old="+currTextValue+" Attr="+node.getAttributes().toString());
    currTextValue = "";
  }

  void new_actionPerformed(ActionEvent e) {
    domModel.insertInCurrentNode(new TreeModelEvent(e.getSource(), fontsTree.getSelectionPath()), e.getActionCommand());
//    fontsTree.scrollPathToVisible(new TreePath( fontsTree.getSelectionPath().getLastPathComponent()));
  }

  void deleteButton_actionPerformed(ActionEvent e) {
    TreePath path = fontsTree.getSelectionPath();
    if(path.getParentPath() == null)
      return;
    domModel.removeCurrentNode(new TreeModelEvent(e.getSource(), path));
    fontsTree.setSelectionPath(path.getParentPath());
//    fontsTree_removeCurrentNode(new TreeModelEvent(e.getSource(), fontsTree.getSelectionPath()));
  }

  void browseButton_actionPerformed(ActionEvent e, Element node) {
    JFileChooser fc = new JFileChooser();
    currTextValue = xmlTextField.getText();
    fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    int returnVal = fc.showOpenDialog(this);
    if (returnVal == JFileChooser.APPROVE_OPTION) {
    try {
          xmlTextField.setText(fc.getSelectedFile().toURL().toExternalForm());

          textField_focusLost(new FocusEvent(xmlTextField,e.getID(),true),node);
///          configElement.setAttribute("xml:base", xmlTextField.getText());
        }
        catch (MalformedURLException ex) {
          xmlTextField.setText("");//"Invalid URL for xml:base. Value not defined");
        }
    }
  }

  void embedComboBox_actionPerformed(ActionEvent e) {
    if (this.fontNode == null) return;
    String txt = embedComboBox.getSelectedItem().toString();
    if(txt.equalsIgnoreCase(COMBO_VALUE[0])){
      if(fontNode.getAttribute("embed") != null)
        fontNode.removeAttribute("embed");
    }
    else fontNode.setAttribute("embed",  COMBO_VALUE[embedComboBox.getSelectedIndex()]);
  }

  void subsetComboBox_actionPerformed(ActionEvent e) {
    if (this.fontNode == null) return;
    String txt = subsetComboBox.getSelectedItem().toString();
    if(txt.equalsIgnoreCase(COMBO_VALUE[0])){
      if(fontNode.getAttribute("subset") != null)
        fontNode.removeAttribute("subset");
    }
    else fontNode.setAttribute("subset",COMBO_VALUE[subsetComboBox.getSelectedIndex()]);
  }

  void addDataButton_actionPerformed(ActionEvent e, Element parent) {
    DomToTableModel tm;
    if(fontDetTable == null){
      tm = new DomToTableModel(parent, true);
/////////////System.out.println(" Font="+parent.toString());
      fontDetTable = new JTable(tm);
      fontDetScrollPane.getViewport().add(fontDetTable, null);
      fontDetScrollPane.updateUI();
    }
    else tm = (DomToTableModel) fontDetTable.getModel();
    tm.addRow(parent);
  }

  void deleteDataButton_actionPerformed(ActionEvent e, Element parent) {
    int row = fontDetTable.getSelectedRow();
    if(row < 0) return;
//////System.out.println(" Font="+parent.toString()+" sss="+this.fontDetTable.getValueAt(0,0));
    DomToTableModel tm = (DomToTableModel) fontDetTable.getModel();
    Attr temp = (Attr) tm.getNodeAt(row);
    Element fdata = (Element)parent.getElementsByTagName("font-data").item(0);
    fdata.removeAttributeNode(temp);
    tm.deleteRow(row);
  }

}
