/*
 * Created on Feb 3, 2005
 *
 * (C) 2005 Amin Ahmad and Ahmadsoft Partners Ltd.
 */
package org.ahmadsoft.xepbridge.ui.preferences;

import org.ahmadsoft.xepbridge.IConstants;
import org.ahmadsoft.xepbridge.XepbridgePlugin;
import org.eclipse.jface.preference.FieldEditorPreferencePage;
import org.eclipse.jface.preference.FileFieldEditor;
import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPreferencePage;

/**
 *
 *
 * @author Admin
 */
public class XepPreferences extends FieldEditorPreferencePage implements
        IWorkbenchPreferencePage {
    
    public XepPreferences() {
        super(FieldEditorPreferencePage.GRID);
            
        // Set the preference store for the preference page.
        IPreferenceStore store =
            XepbridgePlugin.getDefault().getPreferenceStore();
        setPreferenceStore(store);
    }
    protected void createFieldEditors() {
        
        FileFieldEditor configFile = new FileFieldEditor(
            IConstants.PREF_CONFIG,
            "&Configuration File:",
            true,
            getFieldEditorParent());
        configFile.setEmptyStringAllowed(false);
        addField(configFile);   
    }

    /**
     * @inheritdoc
     */
    public void init(IWorkbench workbench) {
    }

}
